"use strict";

var _regenerator = require("babel-runtime/regenerator");

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require("babel-runtime/helpers/asyncToGenerator");

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var generateReference = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
    var cwd, pkgJson, projectSuffix, destFileLocation, mainFileLocation, basePath, mainFileRelativeWithoutExt, destFileRelativeWithoutExt, dtsGlobPath, pathes, filteredPath, i, jsFiles, _pathes, _filteredPath, _i;

    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            _context.next = 3;
            return (0, _asyncHelper.templateCompileAsync)(_path2.default.normalize(__dirname + "/../../src/buildUtil/ref-template.template"));

          case 3:
            refGen = _context.sent;
            cwd = process.cwd(); // current working directory

            _context.t0 = JSON;
            _context.next = 8;
            return (0, _asyncHelper.readFileAsync)(_path2.default.join(cwd, "package.json"));

          case 8:
            _context.t1 = _context.sent;
            pkgJson = _context.t0.parse.call(_context.t0, _context.t1);
            projectSuffix = (0, _common.getSuffix)(pkgJson.name);
            destFileLocation = _path2.default.resolve(_path2.default.join(cwd, _yargs.argv.dest));
            mainFileLocation = _path2.default.resolve(_path2.default.join(cwd, _yargs.argv.main));
            basePath = _path2.default.join(cwd, _yargs.argv.src); // absolute path of source directory

            mainFileRelativeWithoutExt = _path2.default.relative(basePath, mainFileLocation).replace(/\.ts|\.js/, "");
            destFileRelativeWithoutExt = _path2.default.relative(basePath, destFileLocation).replace(/\.ts|\.js/, "");

            if (!_yargs.argv.ts) {
              _context.next = 36;
              break;
            }

            // Typescript
            dtsGlobPath = _path2.default.join(cwd, _yargs.argv.dts, "**/*.d.ts");
            _context.next = 20;
            return (0, _asyncHelper.globAsync)(dtsGlobPath);

          case 20:
            pathes = _context.sent;
            filteredPath = pathes.map(function (p) {
              return _path2.default.relative(_path2.default.resolve(cwd, _yargs.argv.dts), p);
            }).map(function (p) {
              return p.replace(/\.d\.ts$/, "");
            }).filter(function (f) {
              return f !== mainFileRelativeWithoutExt;
            });

            if (_yargs.argv.debug) {
              console.log(_chalk2.default.cyan("Filtered js generation path:\n" + filteredPath));
            }
            i = 0;

          case 24:
            if (!(i < filteredPath.length)) {
              _context.next = 34;
              break;
            }

            if (!(filteredPath[i] === destFileRelativeWithoutExt)) {
              _context.next = 29;
              break;
            }

            _context.next = 28;
            return (0, _asyncHelper.writeFileAsync)(_path2.default.join(cwd, _yargs.argv.dts, filteredPath[i] + ".js"), genRefCode([], projectSuffix));

          case 28:
            return _context.abrupt("continue", 31);

          case 29:
            _context.next = 31;
            return (0, _asyncHelper.writeFileAsync)(_path2.default.join(cwd, _yargs.argv.dts, filteredPath[i] + ".js"), genRefCode(filteredPath[i].split(_path2.default.sep), projectSuffix));

          case 31:
            i++;
            _context.next = 24;
            break;

          case 34:
            _context.next = 57;
            break;

          case 36:
            jsFiles = _path2.default.join(cwd, _yargs.argv.src, "**/*.js");
            _context.next = 39;
            return (0, _asyncHelper.globAsync)(jsFiles);

          case 39:
            _pathes = _context.sent;
            _filteredPath = _pathes.map(function (p) {
              return _path2.default.relative(_path2.default.resolve(cwd, _yargs.argv.src), p);
            }).map(function (p) {
              return p.replace(/\.js$/, "");
            }).filter(function (f) {
              return f !== mainFileRelativeWithoutExt;
            });

            if (_yargs.argv.debug) {
              console.log(_chalk2.default.cyan("Filtered js generation path:\n" + _filteredPath));
            }
            _i = 0;

          case 43:
            if (!(_i < _filteredPath.length)) {
              _context.next = 57;
              break;
            }

            if (!(_filteredPath[_i] === destFileRelativeWithoutExt)) {
              _context.next = 50;
              break;
            }

            _context.next = 47;
            return (0, _asyncHelper.writeFileAsync)(_path2.default.join(cwd, _yargs.argv.dts, _filteredPath[_i] + ".js"), genRefCode([], projectSuffix));

          case 47:
            _context.next = 49;
            return (0, _asyncHelper.writeFileAsync)(_path2.default.join(cwd, _yargs.argv.dts, _filteredPath[_i] + ".d.ts"), genDtsCode(true));

          case 49:
            return _context.abrupt("continue", 54);

          case 50:
            _context.next = 52;
            return (0, _asyncHelper.writeFileAsync)(_path2.default.join(cwd, _yargs.argv.dts, _filteredPath[_i] + ".js"), genRefCode(_filteredPath[_i].split(_path2.default.sep), projectSuffix));

          case 52:
            _context.next = 54;
            return (0, _asyncHelper.writeFileAsync)(_path2.default.join(cwd, _yargs.argv.dts, _filteredPath[_i] + ".d.ts"), genDtsCode(false));

          case 54:
            _i++;
            _context.next = 43;
            break;

          case 57:
            _context.next = 62;
            break;

          case 59:
            _context.prev = 59;
            _context.t2 = _context["catch"](0);

            console.log(_context.t2);

          case 62:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this, [[0, 59]]);
  }));

  return function generateReference() {
    return _ref.apply(this, arguments);
  };
}();

var _path = require("path");

var _path2 = _interopRequireDefault(_path);

var _asyncHelper = require("../async-helper");

var _yargs = require("yargs");

var _common = require("./common");

var _chalk = require("chalk");

var _chalk2 = _interopRequireDefault(_chalk);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var refGen = void 0;
function genRefCode(separatedPath, libSuffix) {
  var sepPath = "";
  for (var i = 0; i < separatedPath.length; i++) {
    sepPath += "/" + separatedPath[i];
  }
  return refGen({
    libSuffix: (!_yargs.argv.core ? libSuffix : "grimoirejs") + "/ref",
    separatedPath: sepPath
  });
}

function genDtsCode(isIndex) {
  if (isIndex) {
    return "declare var __PACKAGE_DECL__:{\n        __VERSION__:string;\n        __NAME__:string;\n        [key:string]:any;\n      };\nexport default __PACKAGE_DECL__;";
  } else {
    return "declare var __MODULE_DECL__:any;\n  export default __MODULE_DECL__;";
  }
}

generateReference();